﻿//   LSG Series Serial Sample Program　for VC# 2008 or Higher
//   Please Open project (LSG_Access.csproj), NOt Open Solution
//   ソリューションファイルでなくプロジェクトファイル(LSG_Access.csproj)を開いてください。

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LSG_Access
{
    public partial class LSG_Access : Form
 
    {
        public int Opened;

        // Open Window
        public LSG_Access()
        {
            InitializeComponent();

            Opened = 0;
            for (int i = 1; i < 30; i++)
                cmbAddress.Items.Add(i);
            cmbAddress.SelectedIndex = 0;

            // Set form
            btnOpen_Close.Text = "OPEN";
            btnLoad.Enabled = false;
            btnCCmode.Enabled = false;
            btnCPmode.Enabled = false;
            btnCRmode.Enabled = false;
            btnCVmode.Enabled = false;
            btnMonitor.Enabled = false;
            btnValueSet.Enabled = false;
            cmbAddress.Enabled = true;
        }

        // Form Close(x Button)
        private void Form1_FormClosing(object sender,FormClosingEventArgs e)
        {
            // Device Close
            if (cmbAddress.Enabled == false)
            {
                serialPort1.WriteLine(":INP OFF;:UTIL:REM OFF\n");
                System.Threading.Thread.Sleep(200);
            }
            if (Opened != 0)
            {
                serialPort1.Close();
            }
        }
        // Open/Close Button
        private void btnOpen_Close_Click(object sender, EventArgs e)
        {
            if(btnOpen_Close.Text == "OPEN"){
                try
                {
                    Opened = 1;
                    Cursor.Current = Cursors.WaitCursor;
                    // Device Open and Init
                    serialPort1.PortName = "COM" + (cmbAddress.SelectedIndex + 1).ToString();
                    serialPort1.BaudRate = 9600;
                    serialPort1.DataBits = 8;
                    serialPort1.StopBits = System.IO.Ports.StopBits.One;
                    serialPort1.Parity = System.IO.Ports.Parity.None;
                    serialPort1.Handshake = System.IO.Ports.Handshake.None;
                    serialPort1.Open();
                    serialPort1.DiscardInBuffer();

                    serialPort1.WriteLine("*cls;:INP OFF;:MODE CC;:INP:MODE LOAD;:MODE:CRAN HIGH;:MODE:VRAN HIGH;:UTIL:LOAD:MODE OFF\n");
                    lblUnit.Text = "A";
                    btnLoad.Text = "LOAD ON";

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnLoad.Enabled = true;
                    btnCCmode.Enabled = true;
                    btnCPmode.Enabled = true;
                    btnCRmode.Enabled = true;
                    btnCVmode.Enabled = true;
                    btnMonitor.Enabled = true;
                    btnValueSet.Enabled = true;
                    cmbAddress.Enabled = false;

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else{
                try
                {
                    // Device Close
                    serialPort1.WriteLine(":INP OFF;:UTIL:REM OFF\n");
                    System.Threading.Thread.Sleep(200);
                    serialPort1.Close();

                    // Set form
                    btnOpen_Close.Text = "OPEN";
                    btnLoad.Enabled = false ;
                    btnCCmode.Enabled = false ;
                    btnCPmode.Enabled = false ;
                    btnCRmode.Enabled = false ;
                    btnCVmode.Enabled = false ;
                    btnMonitor.Enabled = false ;
                    btnValueSet.Enabled = false ;
                    cmbAddress.Enabled = true ;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }

        }
        
        // CC Button
        private void btnCCmode_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(":MODE CC\n");
            lblUnit.Text  = "A";
        }

        // CP Button
        private void btnCPmode_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(":MODE CP\n");
            lblUnit.Text = "W";
        }

        // CR Button
        private void btnCRmode_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(":MODE CR\n");
            lblUnit.Text = "mS";
        }

        // CV Button
        private void btnCVmode_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(":MODE CV\n");
            lblUnit.Text = "V";
        }

        // Load Button
        private void btnLoad_Click(object sender, EventArgs e)
        {
            if (btnLoad.Text == "LOAD ON")
            {
                // OFF -> ON
                serialPort1.WriteLine(":INP ON\n");
                btnLoad.Text = "LOAD OFF";
            }
            else
            {
                // ON -> OFF
                serialPort1.WriteLine(":INP OFF\n");
                btnLoad.Text = "LOAD ON";
            }
        }

        // Set Button
        private void btnValueSet_Click(object sender, EventArgs e)
        {
            string SendMsg = "";
            if (lblUnit.Text == "A") SendMsg = ":CURR ";
            else if (lblUnit.Text == "W") SendMsg = ":POW ";
            else if (lblUnit.Text == "V") SendMsg = ":VOLT ";
            else if (lblUnit.Text == "mS") SendMsg = ":RES ";
            else SendMsg = "";

            if (SendMsg != "")
            {
                SendMsg = SendMsg + ReplaceCommonEscapeSequences(txtValue.Text);
                try
                {
                    serialPort1.WriteLine(SendMsg);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
         }

        // Monitor Button
        private void btnMonitor_Click(object sender, EventArgs e)
        {
            string txtVoltage, txtCurrent, txtPower;
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                serialPort1.WriteLine(":MEAS:VOLT?\n");
                System.Threading.Thread.Sleep(200);
                txtVoltage = serialPort1.ReadExisting() + " V\r\n";
                serialPort1.WriteLine(":MEAS:CURR?\n");
                System.Threading.Thread.Sleep(200);
                txtCurrent = serialPort1.ReadExisting() + " A\r\n";
                serialPort1.WriteLine(":MEAS:POW?\n");
                System.Threading.Thread.Sleep(200);
                txtPower = serialPort1.ReadExisting() + " W\r\n";
                txtMeasure.Text = txtCurrent + txtVoltage + txtPower;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private string ReplaceCommonEscapeSequences(string s)
        {
            return s.Replace("\\n", "\n").Replace("\\r", "\r");
        }

        private string InsertCommonEscapeSequences(string s)
        {
            return s.Replace("\n", "\\n").Replace("\r", "\\r");
        }


    }
}
